#!/usr/bin/ruby

# created by Hannes Petri
# feel free to do what you want with this script, but it would be nice if you kept this little text

class String
  def pattern_final?
    not self.include? '{' and not self.include? '}' and not self.include? '[' and not self.include? ']'
  end
  def list_entries
    tmp = self.dup.gsub(' ', '') << ','
    entries = []
    
    level = 0
    last_index = 0
 
    tmp.length.times do |x|
      case tmp[x].chr
        when '{' then level += 1
        when '}' then level -= 1
        when ','
          if level == 0
            entries << tmp[last_index...x]
            last_index = x + 1
          end
      end
    end
    entries
  end
  def numeric_string?
    return ( ( self =~ /^\d+$/ ).nil? ? false : true )
  end
end

def urls_from_url_pattern( url, a_list = nil )  
  return ["#{url}"] if url.pattern_final?
  
  closures = {'{' => '}', '[' => ']'}
  openings = {'}' => '{', ']' => '['}
  
  closure = nil
  opening = nil
  
  start = 0
  range = nil
  level = 0
  a_list = [] if a_list.nil?
  fresh_urls = []
  
  url.length.times do |t|
    if url[t].chr == opening and level > 0
       level += 1
    end
    if closures.keys.include? url[t].chr and level == 0
      start = t
      level += 1
      closure = closures[url[t].chr]
      opening = openings[closure]
    end
    if url[t].chr == closure
      level -= 1
      if level == 0
        if closure == "}"
          entries_string = url[(start + 1)..(t - 1)].list_entries.each do |entry|
            fresh_url = url.dup
            fresh_url[start..t] = entry
            fresh_urls << fresh_url
          end
        elsif closure == ']'
          range_string = url[(start + 1)..(t - 1)]
          r = range_string.split '-'
          
          if not r[1].numeric_string? or not r[0].numeric_string?
            if r[1] < r[0] 
              the_range = r[1]..r[0]
            else
              the_range = r[0]..r[1]
            end
          else
            if r[1].to_i < r[0].to_i
              if r[0].length == r[1].length
                the_range = r[1]..r[0]
                first_len = r[1].length
              else
                the_range = (r[1].to_i)..(r[0].to_i)
              end
            else
              if r[0].length == r[1].length
                the_range = r[0]..r[1]
              else
                first_len = r[0].length
                the_range = (r[0].to_i)..(r[1].to_i)
              end
            end 
          end
                    
          the_range.each do |x|
            fresh_url = url.dup
            insert = first_len.nil? ? x.to_s : x.to_s.rjust( first_len, '0' )
            fresh_url[start..t] = insert
            fresh_urls << fresh_url   
          end
          
          first_len = nil
        end
      end
    end
  end  
  fresh_urls.each do |x|
    if x.pattern_final?
      a_list << x
    else
      urls_from_url_pattern( x, a_list )
    end
  end
  return a_list.uniq.reject { |x| x.nil? }
end

puts urls_from_url_pattern( gets ).join( "\n" )